import java.util.*;

public class MegaLaevandus {

    class Square{
	boolean bombarded=false;
	Integer contents;
    }

    public Integer numberOfShips = new Integer(0);
    public Map shipregistry = new HashMap();
    private Square[][] waterTable;

    MegaLaevandus(){
	//waterTable=new Square[10][10];
	this(10,10);
    }
    
    MegaLaevandus(int colsAndRows){
	//waterTable=new Square[n][n];
	this(colsAndRows,colsAndRows);
    }
    
    MegaLaevandus(int cols, int rows){
	waterTable=new Square[rows][cols];
	System.out.println(waterTable.length);
    }
    
    public int getRows(){
    	return(waterTable.length);
    }

    public int getCols(){
    	return(waterTable[0].length);
    }

    public int getContents(int x, int y){
	if ((waterTable[y][x]==null)||(waterTable[y][x].contents==null))
	    return(0);
	else
	    return(waterTable[y][x].contents.intValue());
    }

    public boolean isBombarded(int x, int y){

	if(waterTable[y][x]==null)
	    return(false);

	return(waterTable[y][x].bombarded);
    }

    //returns if the ship(that has height and width can be placed at certain
    //location specified by x and y
    //and places it as it is phossible.

    public int asetaLaev(Ship laev, int x, int y){
	return(asetaLaev(laev.getWidth(), laev.getHeight(), x, y));
    }

    public int asetaLaev(int laius, int pikkus, int x, int y){
	System.out.println("LaevAsetada: w" + laius + " h" + pikkus + " x" + x + " y" + y); 
	if(! mahub(laius, pikkus, x, y) )
	    return(0);

	numberOfShips = new Integer(numberOfShips.intValue() + 1);
	Integer laiv = (Integer)shipregistry.get(numberOfShips);
	shipregistry.put(numberOfShips, new Integer(pikkus*laius));	    

	for(int m=y; m<pikkus+y; m++){
	    for (int n=x; n<laius+x; n++){
		if(waterTable[m][n]==null)
		    waterTable[m][n] = new Square();

		if (waterTable[m][n].contents==null){
		    waterTable[m][n].contents = numberOfShips;}
		else {
		    System.out.println("Weird.. ");
		    waterTable[m][n].contents = numberOfShips;}
		}
	    }
	tryki();
	return(laius*pikkus);
    }

    //returns -1 if missed
    //returns 0 if not worth to shoot,
    //returns 1 if ship has been hit and
    //returns 2 if ship is starting to sink..
    public int shootAt(int targetX, int targetY){
	System.out.println();

	if(waterTable[targetY][targetX]==null){
	    waterTable[targetY][targetX] = new Square();
	    System.out.println("waterTable"+targetX+targetY+" was pointing to nowhere");
	    waterTable[targetY][targetX].bombarded=true;
	    System.out.println("Mda!");
	    return(-1);
	}

	if(waterTable[targetY][targetX].bombarded){
    	    System.out.println("waterTable"+targetX+targetY+".bombarded is true");
	    return(0);
	}

	waterTable[targetY][targetX].bombarded=true;
	System.out.println("waterTable"+targetX+targetY+".bombarded was just set to true");

	Integer laivuke = (Integer)shipregistry.get(waterTable[targetY][targetX].contents);
	if (laivuke==null){
	    System.out.println("Midagi kummalist on lahti..");
	    System.out.println("Mda!");
	    return(-1);
	}
	if(laivuke.intValue() > 1){
	    System.out.println("Pihtas!");
	    shipregistry.put(waterTable[targetY][targetX].contents,new Integer(laivuke.intValue()-1));
	    return(1);}
	
	 System.out.println("Phjas!");
	 shipregistry.remove(waterTable[targetY][targetX].contents);
	 return(2);
    }

    void tryki(){
	for(int n=0; n<waterTable.length; n++){
	    for(int m=0; m<waterTable[n].length; m++){
		if (waterTable[n][m]==null) System.out.print("0");
		else System.out.print(waterTable[n][m].contents);
	    }
	System.out.println();
	}
	System.out.println(shipregistry);
    }

    
    //returns false if Kind of ship(that has widt and height) fits to the
    //place specified by x and y :)
    public boolean mahub(Ship laev, int x, int y){
	return(mahub(laev.getWidth(), laev.getHeight(), x, y));
    }

    public boolean mahub(int laius, int pikkus, int x, int y){
	
	if( ((laius + x) > getCols() ) || ( (pikkus + y) > getRows() ))
	    return(false);
	    
	for(int m=y-1; m<=y+pikkus; m++){
	    for(int n=x-1;n<=x+laius;n++){
		if(( m>=0 && m<waterTable.length) && ( n>=0 && n<waterTable[m].length )){
		    if(waterTable[m][n]==null)
			continue;
		    if( waterTable[m][n].contents!=null){
			return(false);
		    }
		}
	    }
	}
	return(true);
    }

    public boolean[][] mouseMan(Ship laiv, int x, int y){
    	return(mouseMan(laiv.getWidth(), laiv.getHeight(), x, y));
    }
    

    public boolean[][] mouseMan(int laius, int pikkus, int x, int y){
    
    	boolean[][] data = new boolean[pikkus+2][laius+2];
	    
    	for(int m=y-1; m<=y+pikkus; m++){
	    for(int n=x-1;n<=x+laius;n++){
		if(( m>=0 && m<waterTable.length) && ( n>=0 && n<waterTable[0].length )){
		    if((waterTable[m][n]==null)||(waterTable[m][n].contents==null)){
		    	//System.out.println("data["+(m-y+1)+"]["+(n-x+1)+"]");
		    	data[m-y+1][n-x+1]=true;
		    }else{
		    	data[m-y+1][n-x+1]=false;
		    }
		}
	    }
	}
	return(data);
    }

}
