import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;

public class Teistmoodi extends JApplet {
    ActionPanel playerPanel;

    public void init(){
	joonistaMagedus(getContentPane());
    }

    public String getAppletInfo(){
	return("Martin Ott Javat Katsetamas");
    }

    public static void main(String s[]){
	JFrame frame = new JFrame("SwingiFreim");

	frame.addWindowListener(new WindowAdapter(){
		public void windowClosing(WindowEvent e){
		    System.exit(0);
		}
	    }); 

	Teistmoodi tegelikkus = new Teistmoodi();
	tegelikkus.joonistaMagedus(frame.getContentPane());
		
	frame.pack();
	frame.setVisible(true);
    }

    void joonistaMagedus(Container joonistuskoht){
	BoxLayout layOut = new BoxLayout(joonistuskoht, BoxLayout.Y_AXIS);
	joonistuskoht.setLayout(layOut);

	JPanel unistusPaneel = new JPanel();
	unistusPaneel.setLayout(new BoxLayout(unistusPaneel, BoxLayout.Y_AXIS));
	unistusPaneel.setOpaque(true);
	unistusPaneel.setPreferredSize(new Dimension(300, 300));
	unistusPaneel.setBorder(BorderFactory.createTitledBorder("Ma sulle siin pommitan!"));

	playerPanel = new ActionPanel();
	playerPanel.setOpaque(true);
	playerPanel.setBorder(BorderFactory.createLineBorder(Color.black));
	playerPanel.showCursor(true);
	playerPanel.addMouseMotionListener( new MouseMotionAdapter(){
		public void mouseMoved(MouseEvent e){
		    playerPanel.drawCursor(e.getPoint());
		}
	    });

	unistusPaneel.add(playerPanel);
	joonistuskoht.add(unistusPaneel);
    }
}

class ActionPanel extends JPanel implements ComponentListener {
    final int COLS = 10;
    final int ROWS = 10;

    int xErr, yErr, rectWidth, rectHeight;
    Point cursor = new Point(0, 0);
    BufferedImage bi;
    boolean cursorNeeded;

    public ActionPanel(){
	addComponentListener(this);
    }

    public void showCursor(boolean cond){
	cursorNeeded = cond;
    }

    public void drawCursor(Point point){
	int oldx=cursor.x, oldy=cursor.y;
	cursor=point;
	repaint(oldx*rectWidth+xErr, oldy*rectHeight+yErr, rectWidth, rectHeight);
	repaint(cursor.x*rectWidth+xErr, cursor.y*rectHeight+yErr, rectWidth, rectHeight);
    }

    public void updateBufImage() {
	bi=new BufferedImage(getWidth(), getHeight(), BufferedImage.TYPE_INT_RGB);
	Graphics g2 = bi.createGraphics();
	for(int n=0; n<COLS; n++) {
	    for(int m=0; m<ROWS; m++){
		g2.setColor(Color.black);
		g2.drawRect(n*rectWidth+xErr, m*rectHeight+yErr, rectWidth-1, rectHeight-1);
		g2.setColor(Color.blue);
		g2.fillRect(n*rectWidth+xErr+1, m*rectHeight+yErr+1, rectWidth-2, rectHeight-2);
	    }
	}
    }

    public void paintComponent(Graphics g){
	super.paintComponent(g);
	g.drawImage(bi, 0, 0, this);
	if (cursorNeeded){
	    g.setColor(Color.white);
	    //g.drawRect(cursor.x*rectWidth+xErr+1, cursor.y*rectHeight+yErr+1, rectWidth-3, rectHeight-3);
	    g.drawRect(cursor.x, cursor.y, rectWidth-3, rectHeight-3);
	}
    }

    //ComponentListener...
    public void componentHidden(ComponentEvent e){}
    public void componentMoved(ComponentEvent e){}
    public void componentResized(ComponentEvent e){
	//Set the neccessary variables
	int width = getWidth();
	int height = getHeight();
	xErr=(width%COLS)/2;
	yErr=(height%ROWS)/2;
	rectWidth = width/COLS;
	rectHeight = height/ROWS;

	//And update the drawing..
	updateBufImage();	
    }

    public void componentShown(ComponentEvent e){}
}
