import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.util.Random;

public class ViewingPanel extends JPanel implements ComponentListener,  ActionListener {

    final int COLS;
    final int ROWS;

    MegaLaevandus shipData;

    Point cursor = new Point(0,0);
    int x, y, xErr, yErr, rectWidth, rectHeight;
    int width, height;
    BufferedImage bi;
    boolean mouseOver;
    Lollus kala;
    Random gene;

    public ViewingPanel(MegaLaevandus shipData){
	kala=new Lollus();
    	gene=new Random();

	this.shipData=shipData;    
	//COLS=10; ROWS=10;
	ROWS=shipData.getRows();
	COLS=shipData.getCols();
	addComponentListener(this);
    }

    public void updateBufImage() {
	bi=new BufferedImage(width, height, BufferedImage.TYPE_INT_RGB);
	Graphics g2 = bi.createGraphics();
	for(int n=0; n<ROWS; n++) {
	    for(int m=0; m<COLS; m++){
		g2.setColor(Color.black);
		g2.drawRect(m*rectWidth+xErr, n*rectHeight+yErr, rectWidth-1, rectHeight-1);
		//System.out.println("asked "+m+", "+n);
		if(shipData.getContents(m,n)>0)
		   if(shipData.isBombarded(m,n))
		        g2.setColor(new Color(255, 200, 0));
		    else
		        g2.setColor(Color.yellow);
		else
		    g2.setColor(Color.blue);

		g2.fillRect(m*rectWidth+xErr+1, n*rectHeight+yErr+1, rectWidth-2, rectHeight-2);
		
	        if(shipData.isBombarded(m,n)){
		    g2.setColor(Color.white);
		    g2.drawLine(m*rectWidth+xErr, n*rectHeight+yErr, m*rectWidth+xErr+rectWidth, n*rectHeight+yErr+rectHeight);
		    g2.drawLine(m*rectWidth+xErr, n*rectHeight+yErr+rectHeight, m*rectWidth+xErr+rectWidth, n*rectHeight+yErr);
		 }
	    }
	}
    }
    
    //Mnjah.. kui see meetod vlja kutsuda, siis ritab teha mingi suvalise lasu kuskile.. eiteakuhu
    public void shoot(){
    	int res;
	
	do{
	    do{
	    	res=shipData.shootAt(gene.nextInt(10), gene.nextInt(10));
	    }while(res == 0);
	    updateBufImage();
	    repaint();
	    //Thread.sleep(400);
	}while(res != -1);
    	kala.spanel.timeToShoot();
    }
/**
* called by swing when It needs redrawing.
* 
*/
    public void paintComponent(Graphics g){
	super.paintComponent(g);
	//Lets see.. what do we have to paint inside. There is the buffered image of the contents...
	if(bi != null)
	   g.drawImage(bi, 0, 0, this);
   }

    //Componentlisteners stuff...
    public void componentHidden(ComponentEvent e){System.out.println("Hidden");}
    public void componentMoved(ComponentEvent e){System.out.println("Moved");}
    public void componentResized(ComponentEvent e){
	//Set the neccessary variables
	System.out.println("Resized: w"+getWidth()+", h"+getHeight());
	width = getWidth();
	height = getHeight();
	xErr=(width%COLS)/2;
	yErr=(height%COLS)/2;
	rectWidth = width/COLS;
	rectHeight = height/ROWS;

	//And update the drawing..
	updateBufImage();
	repaint();
    }
    public void componentShown(ComponentEvent e){System.out.println("shown");}

    //ActionListener
    public void actionPerformed(ActionEvent e){
       System.out.println(e);
    }
}

